Scriptname LoversComfortConfigScr extends SKI_ConfigBase  

; lovers comfort
LoversComfortUtilScr Property lcUtil Auto

; general settings
bool Property IsRapeMaleAnim Auto
bool Property IsFFuseFM Auto
GlobalVariable Property IsDialoguesEnabled Auto

; OnSleep
bool Property IsOnSleepMastrubate Auto
bool Property IsOnSleepSpouse Auto
bool Property IsOnSleepFollower Auto

; NPC
bool Property IsIncest Auto
bool Property IsMF Auto
bool Property IsMM Auto
bool Property IsFF Auto
bool Property IsNPCMastrubate Auto

; spouse
bool Property IsSpouseGay Auto
bool Property IsSpouseScenesEnabled Auto
int Property SpouseArousalThreshold Auto

; OIDs
int RapeMaleAnimOID
int FFuseFMOID
int DialoguesEnabledOID

int OnSleepFollowerOID
int OnSleepMastrubateOID
int OnSleepSpouseOID

int SpouseGayOID
int SpouseArousalThresholdOID
int SpouseScenesEnabledOID

int IncestOID
int MFOID
int MMOID
int FFOID
int NPCMastrubateOID

; page names
string pgSettings = "$LC_Settings"
string pgStatus = "$LC_Status"

; variables
bool IsStatusLocked = false

int Function GetVersion()
	return 8
EndFunction


Event OnVersionUpdate(int a_version)
	; a_version is the new version, CurrentVersion is the old version
	If (a_version >= 7 && CurrentVersion < 7)
		Debug.Trace(self + ": Updating script to version 7")
		Pages = new string[2]
		Pages[0] = pgSettings
		Pages[1] = pgStatus
		IsStatusLocked = false
	EndIf
EndEvent


Function Maintenance()
	IsStatusLocked = false
EndFunction


Event OnPageReset(string page)

	; Load custom logo in DDS format
	If (page == "")
		int xOffset = 376 - (375 / 2)
		LoadCustomContent("loverscomfort.dds", xOffset, 0)		
		return
	else
		UnloadCustomContent()
	EndIf
	
	If (page == pgSettings)
		Debug.Trace(self + ": trying to open settings page...")
		SetCursorFillMode(TOP_TO_BOTTOM)

		AddTextOption("$LC_Version" , lcUtil.GetVersion(), OPTION_FLAG_DISABLED)
		
		AddEmptyOption()
		
		AddHeaderOption("$LC_General")
		RapeMaleAnimOID = AddToggleOption("$LC_RapeMaleAnim", IsRapeMaleAnim)
		FFuseFMOID = AddToggleOption("$LC_FFuseFM", IsFFuseFM)
		
		If (IsDialoguesEnabled.GetValueInt() < 1)
			DialoguesEnabledOID = AddToggleOption("$LC_DialoguesEnabled", false)
		Else
			DialoguesEnabledOID = AddToggleOption("$LC_DialoguesEnabled", true)
		EndIf
		
		AddHeaderOption("$LC_OnSleepEvents")
		OnSleepSpouseOID = AddToggleOption("$LC_OnSleepSpouse", IsOnSleepSpouse)
		OnSleepMastrubateOID = AddToggleOption("$LC_OnSleepMastrubate", IsOnSleepMastrubate)
		OnSleepFollowerOID = AddToggleOption("$LC_OnSleepFollower", IsOnSleepFollower)
		
		SetCursorPosition(1) ; Move cursor to top right position
				
		AddHeaderOption("$LC_SpouseComfort")
		SpouseGayOID = AddToggleOption("$LC_SpouseGay", IsSpouseGay)
		SpouseArousalThresholdOID = AddSliderOption("$LC_SpouseArousalThreshold", SpouseArousalThreshold, "{0}")
		SpouseScenesEnabledOID = AddToggleOption("$LC_EnableSpouseSences", IsSpouseScenesEnabled)

		AddHeaderOption("$LC_NPCComfort")
		IncestOID = AddToggleOption("$LC_EnableIncest", IsIncest)
		MFOID = AddToggleOption("$LC_EnableMF", IsMF)
		MMOID = AddToggleOption("$LC_EnableMM", IsMM)
		FFOID = AddToggleOption("$LC_EnableFF", IsFF)
		NPCMastrubateOID = AddToggleOption("$LC_EnableMasturbation", IsNPCMastrubate)

	ElseIf (page == pgStatus)
		Debug.Trace(self + ": trying to open status page...")
		If (IsStatusLocked)
			Debug.Trace(self + ": OnPageReset - Status is locked")
			Debug.Notification("Status page is locked :-( , try again latter")
		Else
			IsStatusLocked = true
			
			SetCursorFillMode(TOP_TO_BOTTOM)

			AddHeaderOption("$LC_Player")
			AddTextOption("$LC_ArousalLevel", lcUtil.slaUtil.GetActorArousal(Game.GetPlayer()), OPTION_FLAG_DISABLED)
			
			Actor akSpouse = lcUtil.lcPlayerQuest.GetSpouse()
			If (akSpouse != None)
				AddHeaderOption("$LC_Spouse")
				AddTextOption("$LC_Name", akSpouse.GetLeveledActorBase().GetName(), OPTION_FLAG_DISABLED)
				AddTextOption("$LC_ArousalLevel", lcUtil.slaUtil.GetActorArousal(akSpouse), OPTION_FLAG_DISABLED)
				
				Actor akLover = lcUtil.lcPlayerQuest.GetSpouseLover()
				If (akLover != None)
					AddHeaderOption("$LC_PotentialLover")
					AddTextOption("$LC_Name", akLover.GetLeveledActorBase().GetName(), OPTION_FLAG_DISABLED)
					AddTextOption("$LC_ArousalLevel", lcUtil.slaUtil.GetActorArousal(akLover), OPTION_FLAG_DISABLED)
					AddTextOption("$LC_LoverRank", lcUtil.GetSpouseLoverRank(akLover), OPTION_FLAG_DISABLED)
					AddTextOption("$LC_RelationshipRank", akSpouse.GetRelationshipRank(akLover), OPTION_FLAG_DISABLED)
				EndIf
			EndIf
			
			SetCursorPosition(1) ; Move cursor to top right position
			
			AddHeaderOption("$LC_CurrentFollowers")
			int i = 0
			Actor[] acList = lcUtil.lcPlayerQuest.lcCurrentFollowers
			While (i < acList.length)
				AddTextOption(acList[i].GetLeveledActorBase().GetName(), lcUtil.slaUtil.GetActorArousal(acList[i]), OPTION_FLAG_DISABLED)
				i += 1
			EndWhile
						
			AddHeaderOption("$LC_InCellNPCs")
			AddTextOption("$LC_ValidNPCs", lcUtil.lcPlayerQuest.lcValidActorsInCell, OPTION_FLAG_DISABLED)
			; AddTextOption("$LC_NPCArousalSum", lcUtil.lcPlayerQuest.lcTotalArousalInCell, OPTION_FLAG_DISABLED)
			
			IsStatusLocked = false
		EndIf
	EndIf
EndEvent


Event OnOptionSelect(int option)
	If (option == RapeMaleAnimOID)
		IsRapeMaleAnim = !IsRapeMaleAnim
		SetToggleOptionValue(RapeMaleAnimOID, IsRapeMaleAnim)

	ElseIf (option == FFuseFMOID)
		IsFFuseFM = !IsFFuseFM
		SetToggleOptionValue(FFuseFMOID, IsFFuseFM)
	
	ElseIf (option == OnSleepMastrubateOID)
		IsOnSleepMastrubate = !IsOnSleepMastrubate
		SetToggleOptionValue(OnSleepMastrubateOID, IsOnSleepMastrubate)
		
	ElseIf (option == OnSleepFollowerOID)
		IsOnSleepFollower = !IsOnSleepFollower
		SetToggleOptionValue(OnSleepFollowerOID, IsOnSleepFollower)

	ElseIf (option == DialoguesEnabledOID)
		If (IsDialoguesEnabled.GetValueInt() < 1)
			IsDialoguesEnabled.SetValue(1)
			SetToggleOptionValue(DialoguesEnabledOID, true)
		Else
			IsDialoguesEnabled.SetValue(0)
			SetToggleOptionValue(DialoguesEnabledOID, false)
		EndIf

	ElseIf (option == OnSleepSpouseOID)
		IsOnSleepSpouse = !IsOnSleepSpouse
		SetToggleOptionValue(OnSleepSpouseOID, IsOnSleepSpouse)
			
	ElseIf (option == SpouseGayOID)
		IsSpouseGay = !IsSpouseGay
		SetToggleOptionValue(SpouseGayOID, IsSpouseGay)

	ElseIf (option == SpouseScenesEnabledOID)
		IsSpouseScenesEnabled = !IsSpouseScenesEnabled
		SetToggleOptionValue(SpouseScenesEnabledOID, IsSpouseScenesEnabled)
		
	ElseIf (option == IncestOID)
		IsIncest = !IsIncest
		SetToggleOptionValue(IncestOID, IsIncest)
		
	ElseIf (option == MFOID)
		IsMF = !IsMF
		SetToggleOptionValue(MFOID, IsMF)
		
	ElseIf (option == MMOID)
		IsMM = !IsMM
		SetToggleOptionValue(MMOID, IsMM)
		
	ElseIf (option == FFOID)
		IsFF = !IsFF
		SetToggleOptionValue(FFOID, IsFF)
		
	ElseIf (option == NPCMastrubateOID)
		IsNPCMastrubate = !IsNPCMastrubate
		SetToggleOptionValue(NPCMastrubateOID, IsNPCMastrubate)
				
	EndIf
EndEvent


Event OnOptionSliderOpen(int option)						
	If (option == SpouseArousalThresholdOID)
		SetSliderDialogStartValue(SpouseArousalThreshold as float)
		SetSliderDialogDefaultValue(50)
		SetSliderDialogRange(0, lcUtil.slaUtil.slaArousalCap)
		SetSliderDialogInterval(1)
		
	EndIf
EndEvent


Event OnOptionSliderAccept(int option, float value)					
	If (option == SpouseArousalThresholdOID)
		SpouseArousalThreshold = value as Int
		SetSliderOptionValue(option, value, "{0}")
		
	EndIf
EndEvent


Event OnOptionHighlight(int option)
	If (option == RapeMaleAnimOID)
		SetInfoText("$LC_InfoRapeMaleAnim")

	ElseIf (option == FFuseFMOID)
		SetInfoText("$LC_InfoFFuseFM")
		
	ElseIf (option == OnSleepMastrubateOID)
		SetInfoText("$LC_InfoOnSleepMastrubate")
		
	ElseIf (option == OnSleepFollowerOID)
		SetInfoText("$LC_InfoOnSleepFollower")
	
	ElseIf (option == DialoguesEnabledOID)
		SetInfoText("$LC_InfoDialoguesEnabled")
						
	ElseIf (option == SpouseArousalThresholdOID)
		SetInfoText("$LC_InfoSpouseArousalThreshold")
		
	ElseIf (option == OnSleepSpouseOID)
		SetInfoText("$LC_InfoOnSleepSpouse")

	ElseIf (option == SpouseGayOID)
		SetInfoText("$LC_InfoSpouseGay")
		
	ElseIf (option == SpouseScenesEnabledOID)
		SetInfoText("$LC_InfoEnableSpouseSences")
		
	ElseIf (option == IncestOID || option == MFOID || option == MMOID || option == FFOID || NPCMastrubateOID)
		SetInfoText("$LC_InfoNPCIncest")

	EndIf
EndEvent


Event OnOptionDefault(int option)		
	If (option == RapeMaleAnimOID)
		IsRapeMaleAnim = true ; default value
		SetToggleOptionValue(RapeMaleAnimOID, IsRapeMaleAnim)
		
	ElseIf (option == FFuseFMOID)
		IsFFuseFM = true ; default value
		SetToggleOptionValue(FFuseFMOID, IsFFuseFM)
		
	ElseIf (option == OnSleepMastrubateOID)
		IsOnSleepMastrubate = true ; default value
		SetToggleOptionValue(OnSleepMastrubateOID, IsOnSleepMastrubate)
		
	ElseIf (option == OnSleepFollowerOID)
		IsOnSleepFollower = true ; default value
		SetToggleOptionValue(OnSleepFollowerOID, IsOnSleepFollower)

	ElseIf (option == DialoguesEnabledOID)
		IsDialoguesEnabled.SetValue(1)
		SetToggleOptionValue(DialoguesEnabledOID, true)
						
	ElseIf (option == SpouseArousalThresholdOID)
		SpouseArousalThreshold = 50 ; default value
		SetSliderOptionValue(SpouseArousalThresholdOID, SpouseArousalThreshold as float, "{0}")
		
	ElseIf (option == OnSleepSpouseOID)
		IsOnSleepSpouse = true ; default value
		SetToggleOptionValue(OnSleepSpouseOID, IsOnSleepSpouse)
				
	ElseIf (option == SpouseGayOID)
		IsSpouseGay = true ; default value
		SetToggleOptionValue(SpouseGayOID, IsSpouseGay)

	ElseIf (option == SpouseScenesEnabledOID)
		IsSpouseScenesEnabled = true ; default value
		SetToggleOptionValue(SpouseScenesEnabledOID, IsSpouseScenesEnabled)
	
	ElseIf (option == IncestOID)
		IsIncest = true ; default value
		SetToggleOptionValue(IncestOID, IsIncest)
		
	ElseIf (option == MFOID)
		IsMF = true ; default value
		SetToggleOptionValue(MFOID, IsMF)
		
	ElseIf (option == MMOID)
		IsMM = true ; default value
		SetToggleOptionValue(MMOID, IsMM)
		
	ElseIf (option == FFOID)
		IsFF = true ; default value
		SetToggleOptionValue(FFOID, IsFF)
		
	ElseIf (option == NPCMastrubateOID)
		IsNPCMastrubate = true ; default value
		SetToggleOptionValue(NPCMastrubateOID, IsNPCMastrubate)

	EndIf
EndEvent