Scriptname LoversComfortPlayerScr extends Quest  

; lovers comfort
LoversComfortUtilScr Property lcUtil Auto
LoversComfortConfigScr Property lcConfigQuest Auto
LoversComfortSwingScr Property lcSwing Auto

LoversComfortSpouseScr Property lcSpouseRef Auto
ReferenceAlias Property lcSpouseLoverRef Auto

Actor[] Property lcCurrentFollowers Auto
Faction Property  lcPartyReady Auto

int Property lcValidActorsInCell Auto

; SexLab
SexLabFramework Property SexLab Auto
Static Property SexLabLocationMarker Auto

; vanilla
Actor Property PlayerRef Auto
ReferenceAlias Property LoveInterest Auto
Quest Property RelationshipMarriageFIN Auto

AssociationType Property SpouseAssociation Auto
AssociationType Property SiblingsAssociation Auto
AssociationType Property CousinsAssociation Auto
AssociationType Property CourtingAssociation Auto
AssociationType Property JarlAssociation Auto

; constants
int kNPC = 43

; callback functions
String lcStageStartStr = "OnStageStart"
String lcAnimationEndStr = "OnAnimationEnd"

; thread lock
bool IsScanLocked = false

; misc variables
Cell startScanCell = None
int hostileActorsInCell = 0;

Event OnInit()
;
EndEvent


Function Maintenance()
	RegisterForSleep()
	RegisterForSingleUpdateGameTime(1)
	
	UnregisterForAllModEvents()
	RegisterForModEvent("AnimationEnd", lcAnimationEndStr)
		
	UpdateSpouse()
	
	IsScanLocked = false
EndFunction


Event OnSleepStart(float afSleepStartTime, float afDesiredSleepEndTime)
	ComfortFollowers()
endEvent


Event OnSleepStop(bool abInterrupted)
	If (abInterrupted)
		Debug.Trace(self + ": player sleep was interrupted, not triggering animations")
		return
	EndIf
	
	Actor[] acList = new Actor[2]
	acList[0] = PlayerRef
	acList[1] = None
	Actor Victim = None
	
	UpdateSpouse()
	Actor akSpouse = GetSpouse()

	If (akSpouse != None)
		If (PlayerRef.GetCurrentLocation() == akSpouse.GetCurrentLocation() &&  !akSpouse.IsInFaction(SexLab.AnimatingFaction))
			If (lcUtil.slaUtil.GetActorArousal(akSpouse) > 80)
				acList[1] = akSpouse
				Victim = PlayerRef
			ElseIf (lcConfigQuest.IsOnSleepSpouse || lcUtil.slaUtil.GetActorLastSexTime(akSpouse) < 1)
				acList[1] = akSpouse
			EndIf
		EndIf
	EndIf

	If (acList[1] != None)
		MakeLove(acList, akVictim = Victim)
	ElseIf (lcUtil.slaUtil.GetActorArousal(PlayerRef) > 90 && lcConfigQuest.IsOnSleepMastrubate)
		acList = new Actor[1]
		acList[0] = PlayerRef
		MakeLove(acList)
	EndIf
EndEvent


Event OnUpdate() 
	ScanCurrentCell()
EndEvent


Event OnUpdateGameTime()
	RegisterForSingleUpdateGameTime(1)
	RegisterForSingleUpdate(1.0)
EndEvent


Event OnAnimationEnd(string eventName, string argString, float argNum, form sender)	
	Actor[] actorList = SexLab.HookActors(argString)

	If (actorList.length < 1)
		return
	EndIf
				
	int playerPosition = actorList.Find(PlayerRef)
	int spousePosition = actorList.Find(GetSpouse())
	Actor spouse = GetSpouse()
		
	If (playerPosition >= 0 && spousePosition < 0 && spouse != None)
		lcUtil.slaUtil.UpdateActorExposure(spouse, 2, "PC cheating")
	EndIf
EndEvent


Function SetSelectedFollower(Actor akRef)
	If (akRef == None)
		return
	EndIf
		
	Actor[] tmpList = new Actor[2]
	tmpList[0] = PlayerRef
	tmpList[1] = akRef
	
	MakeLove(tmpList)
EndFunction


bool Function IsPartyReady(Actor akRef)	
	Actor[] tmpList = GetPartyActors(akRef)
	
	If (tmpList.length == 3)
		akRef.SetFactionRank(lcPartyReady, 0)
		return true
	EndIf
	
	akRef.SetFactionRank(lcPartyReady, -2)
	return false
EndFunction


Function StartParty(Actor akRef)
	If (akRef == None)
		return
	EndIf
	
	Actor[] tmpList = GetPartyActors(akRef)
	If (tmpList.length == 3)
		MakeLove(tmpList)
	EndIf
	
	akRef.SetFactionRank(lcPartyReady, -2)
EndFunction


Actor[] Function GetPartyActors(Actor akRef)
	Actor[] tmpList
	
	If (akRef == None)
		return tmpList
	EndIf
	
	tmpList = new Actor[2]
	tmpList[0] = PlayerRef
	tmpList[1] = akRef
	
	Actor ak2 = GetSpouse()
	If (ak2 != None)
		If (akRef != ak2 && PlayerRef.GetParentCell() == ak2.GetParentCell())
			tmpList = sslUtility.PushActor(ak2, tmpList)
		EndIf
	EndIf
	
	int i = 0
	While (i < lcCurrentFollowers.length && tmpList.length < 3)
		ak2 = lcCurrentFollowers[i]
		If (lcUtil.slaUtil.GetActorArousal(ak2) > 30 && PlayerRef.GetParentCell() == ak2.GetParentCell() && ak2 != akRef)
			tmpList = sslUtility.PushActor(ak2, tmpList)
		EndIf
		i += 1
	EndWhile
	
	return tmpList
EndFunction


Actor Function GetSpouse()
	return lcSpouseRef.GetActorReference()
EndFunction


Function SetSpouse(Actor akRef)
	If (akRef != None && lcSpouseRef.GetActorReference() != akRef)
		lcSpouseRef.ForceRefTo(akRef)
	EndIf
EndFunction


Function UpdateSpouse()
	If (RelationshipMarriageFIN.IsRunning() == True && RelationshipMarriageFIN.GetStage() >= 10 && LoveInterest.GetActorRef() != None)
		SetSpouse(LoveInterest.GetActorRef())
	EndIf
EndFunction


Actor Function GetSpouseLover()
	return lcSpouseLoverRef.GetActorReference()
EndFunction


Function SetSpouseLover(Actor akRef)
	If (akRef != None && lcSpouseLoverRef.GetActorReference() != akRef)
		lcSpouseLoverRef.ForceRefTo(akRef)
	EndIf
EndFunction


ObjectReference Function FindBestCenter(Actor[] sexActors)
	ObjectReference res = None
	
	If (sexActors.Find(GetSpouse()) >= 0 && sexActors.Find(GetSpouseLover()) >= 0)
		Float searchRadius = 2500
		res = Game.FindClosestReferenceOfTypeFromRef(SexLabLocationMarker, sexActors[0], searchRadius)
		If (res == None)
			res = Game.FindClosestReferenceOfTypeFromRef(SexLabLocationMarker, sexActors[1], searchRadius)
		EndIf
	EndIf
	
	Return res
EndFunction


Function MakeLove(Actor[] sexActors, Actor AkVictim = None)
	int actorCount = sexActors.length
		
	int i = 0
	While i < actorCount
		If (sexActors[i] == None)
			Debug.Trace(self + ": MakeLove, Error NONE actor")
			return
		ElseIf (sexActors[i].IsChild())
			return
		EndIf
		
		Debug.Trace(self + ": MakeLove found : " + sexActors[i].GetLeveledActorBase().GetName())
		
		i += 1
	EndWhile
									
	sslBaseAnimation[] animations = SelectAnimation(sexActors, AkVictim)
	
	If (animations.length < 1)
		Debug.Trace(self + ": MakeLove, Error unable to select animations")
		return
	EndIf

	ObjectReference center = FindBestCenter(sexActors)
	sexActors = SortActors(sexActors, AkVictim)
			
	int id = SexLab.StartSex(sexActors, animations, victim=AkVictim, centerOn=center)
	If id < 0
		Debug.Notification("SexLab animation failed to start [" + id + "]")
		Debug.Trace(self + ": SexLab animation failed to start [" + id + "]")
	EndIf
EndFunction


Actor[] Function SortActors(Actor[] actorList, Actor akVictim)
	actorList = SexLab.SortActors(actorList)
	
	If (lcConfigQuest.IsRapeMaleAnim && AkVictim != None)
		int i = 0
		While i < actorList.length
			If (actorList[i] == AkVictim)
				actorList[i] = actorList[0]
				actorList[0] = AkVictim
				return actorList
			EndIf
			i += 1
		EndWhile
	EndIf
	
	return actorList
EndFUnction


sslBaseAnimation[] Function SelectAnimation(Actor[] sexActors, Actor vicAk)
	int maleCount = 0
	int femaleCount = 0
	
	int i = 0
	While i < sexActors.length
		If (sexActors[i].GetLeveledActorBase().GetSex() == 0)
			maleCount += 1
		Else
			femaleCount += 1
		EndIf
		i += 1
	EndWhile
	
	sslBaseAnimation[] animations
	
	; masturbation
	If (sexActors.length == 1)
		If (maleCount == 1)
			animations = SexLab.GetAnimationsByTag(1, "Masturbation", "M")
		Else
			animations = SexLab.GetAnimationsByTag(1, "Masturbation", "F")
		EndIf
	EndIf
	
	If (!(lcConfigQuest.IsFFuseFM && maleCount == 0) && animations.length < 1)
		animations = SexLab.GetAnimationsByType(sexActors.length, males = maleCount, females = femaleCount, aggressive = (vicAk != None), sexual = true)
	EndIf
	
	If (animations.length < 1)
		animations = SexLab.GetAnimationsByType(sexActors.length, males = -1, females = -1, aggressive = (vicAk != None), sexual = true)
	EndIf

	If (animations.length < 1)
		animations = SexLab.GetAnimationsByType(sexActors.length, males = -1, females = -1, aggressive = false, sexual = true)
	EndIf
	
	return animations
EndFunction


Function ScanCurrentCell()
;	float ftimeStart = Utility.GetCurrentRealTime()
	Actor akSpouse = GetSpouse()
	
	If (IsScanLocked)
		Debug.Trace(self + ": ScanCurrentCell is locked")
		return
	ElseIf (PlayerRef.IsInCombat())
		Debug.Trace(self + ": ScanCurrentCell is skipped - player in combat")
		return
	ElseIf (PlayerRef.GetParentCell().IsInterior() == false && akSpouse == None)
		Debug.Trace(self + ": ScanCurrentCell is skipped - exterior cell, no spouse")
		return
	ElseIf (PlayerRef.GetParentCell().IsInterior() == false && akSpouse != None)
		If !(PlayerRef.getCurrentLocation() == akSpouse.getCurrentLocation() && !lcUtil.IsCurrentFollower(akSpouse))
			Debug.Trace(self + ": ScanCurrentCell is skipped - exterior cell, no spouse in location")
			return
		EndIf
	EndIf
	
	IsScanLocked = true	
	startScanCell = PlayerRef.GetParentCell()
	Debug.Trace(self + ": ScanCurrentCell started at " + startScanCell.GetName())
	
	Actor[] validActorList = DoFirstScan()
	DoSecondScan(validActorList)
	ComfortLoneNPCs(validActorList)
	
	If (akSpouse != None)
		If (PlayerRef.getCurrentLocation() == akSpouse.getCurrentLocation())
			lcSpouseRef.DoLoversScan(validActorList)
		EndIf
	EndIf
	
;	float ftimeEnd = Utility.GetCurrentRealTime()
;	Debug.Trace(Self + ": ScanCurrentCell took " + (ftimeEnd - ftimeStart) + " seconds to run")

	startScanCell = None
	IsScanLocked = false
EndFunction


Actor[] Function DoFirstScan()
	int NPCcount = startScanCell.GetNumRefs(kNPC)
	
	Actor[] emptyList
	Actor[] validActorList
	Actor[] tmpCurrentFollowers 
	
	hostileActorsInCell = 0
		
	int i = 0
	While (i < NPCcount)
		Actor tmpAk = startScanCell.GetNthRef(i, kNPC) as Actor
		int akRes = lcUtil.IsValidActor(tmpAk)
		If (akRes >= 0)
			validActorList = sslUtility.PushActor(tmpAk, validActorList)
		ElseIf (akRes == -8)
			hostileActorsInCell += 1
		EndIf
		
		If (lcUtil.IsCurrentFollower(tmpAk))
;			Debug.Trace(self + ": added follower " + tmpAk.GetLeveledActorBase().GetName())
			tmpCurrentFollowers = sslUtility.PushActor(tmpAk, tmpCurrentFollowers)
		EndIf
			
		i += 1
	EndWhile
	
	lcValidActorsInCell = validActorList.length
	
	If (startScanCell == PlayerRef.GetParentCell())
		lcCurrentFollowers = tmpCurrentFollowers
	EndIf

	return validActorList
EndFunction


Function DoSecondScan(Actor[] validActorList)
	int i = 0
	While (i < validActorList.length && startScanCell == PlayerRef.GetParentCell())
		Actor tmpAk1 = validActorList[i]
		
		int j = i+1
		While (j < validActorList.length)
			Actor tmpAk2 = validActorList[j]
			If (ComfortNPC(tmpAk1, tmpAk2))
				return
			EndIf
			j += 1
		EndWhile
		
		i += 1
	EndWhile
EndFunction


bool Function ComfortNPC(Actor akRef, Actor tmpAk)
	If (akRef == None || tmpAk == None)
		return false
	EndIf
		
	bool comfortFlag = AreNPCRelated(akRef, tmpAk)
	
	If (comfortFlag)
		lcSwing.AddCouple(akRef, tmpAk)
	EndIf
		
	If (akRef.GetSleepState() != 3 && tmpAk.GetSleepState() != 3)
		comfortFlag = false
	ElseIf (!lcConfigQuest.IsMF && akRef.GetLeveledActorBase().GetSex() != tmpAk.GetLeveledActorBase().GetSex())
		comfortFlag = false
	ElseIf (!lcConfigQuest.IsMM && akRef.GetLeveledActorBase().GetSex() == 0 && tmpAk.GetLeveledActorBase().GetSex() == 0)
		comfortFlag = false
	ElseIf (!lcConfigQuest.IsFF && akRef.GetLeveledActorBase().GetSex() == 1 && tmpAk.GetLeveledActorBase().GetSex() == 1)
		comfortFlag = false
	ElseIf (!lcConfigQuest.IsIncest && (akRef.HasAssociation(SiblingsAssociation, tmpAk) || akRef.HasAssociation(CousinsAssociation, tmpAk)))
		comfortFlag = false
	EndIf

	If (comfortFlag)
		Debug.Trace(self + ": Found : " + tmpAk.GetBaseObject().GetName() + " comforting " + akRef.GetBaseObject().GetName())
		
		Actor[] tmpList = new Actor[2]
		tmpList[0] = tmpAk
		tmpList[1] = akRef

		MakeLove(tmpList)
		return true
	EndIf
	
	return false
EndFunction


bool Function AreNPCRelated(Actor akRef, Actor tmpAk)
	bool comfortFlag = false
	
	If (akRef.GetRelationshipRank(tmpAk) == 4)
		comfortFlag = true
	ElseIf (akRef.HasAssociation(SpouseAssociation, tmpAk))
		comfortFlag = true
	ElseIf (akRef.HasAssociation(JarlAssociation, tmpAk))
		comfortFlag = true
	ElseIf (akRef.HasAssociation(CourtingAssociation, tmpAk))
		comfortFlag = true
	ElseIf (akRef.HasAssociation(SiblingsAssociation, tmpAk))
		comfortFlag = true
	ElseIf (akRef.HasAssociation(CousinsAssociation, tmpAk))
		comfortFlag = true
	EndIf
	
	return comfortFlag
EndFunction


Function ComfortLoneNPCs(Actor[] actorList)
	If (!lcConfigQuest.IsNPCMastrubate)
		Return
	EndIf
	
	int i = 0
	While (i < actorList.length && startScanCell == PlayerRef.GetParentCell())
		Actor tmpAk = actorList[i]
		If (lcUtil.IsValidActor(tmpAk) >= 0)
			If (lcUtil.slaUtil.GetActorArousal(tmpAk) > 75 && tmpAk.GetSleepState() == 3)
				Debug.Trace(self + ": Found : " + tmpAk.GetBaseObject().GetName() + " comforting self")
				Actor[] tmpList = new Actor[1]
				tmpList[0] = tmpAk

				MakeLove(tmpList)
				Return
			EndIf
		EndIf
		i += 1
	EndWhile
EndFunction


Function ComfortFollowers()
	If (!lcConfigQuest.IsOnSleepFollower)
		Return
	EndIf
	
	Actor[] followerList = lcCurrentFollowers
	Actor[] tmpList
	
	int i = 0
	While (i < followerList.length)
		Actor tmpAk = followerList[i]
		Debug.Trace(self + ": comforting follower " + tmpAk.GetLeveledActorBase().GetName())
		If (lcUtil.IsValidActor(tmpAk) >= 0)
			If (lcUtil.slaUtil.GetActorArousal(tmpAk) > 70 && tmpList.length < 3)
				tmpList = sslUtility.PushActor(tmpAk, tmpList)
			EndIf
		EndIf		
		i += 1
	EndWhile
	
	If (tmpList.length > 0 && tmpList.length < 4)
		MakeLove(tmpList)
	EndIf
EndFunction