Scriptname LoversComfortSwingScr extends Quest  

; lovers comfort
LoversComfortUtilScr Property lcUtil Auto
LoversComfortPlayerScr Property lcPlayer Auto

ReferenceAlias Property lcActor01ARef Auto
ReferenceAlias Property lcActor01BRef Auto
ReferenceAlias Property lcActor02ARef Auto
ReferenceAlias Property lcActor02BRef Auto
ReferenceAlias Property lcActor03ARef Auto
ReferenceAlias Property lcActor03BRef Auto

; variable
int couplePointer = 0

Function AddCouple(Actor ak1, Actor ak2)
	Debug.Trace(self + ": trying to add couple : " + ak1.GetBaseObject().GetName() + " comforting " + ak2.GetBaseObject().GetName())
	If (couplePointer == 0)
		lcActor01ARef.ForceRefTo(ak1)
		lcActor01BRef.ForceRefTo(ak2)
		couplePointer = 1
	ElseIf (couplePointer == 1)
		lcActor02ARef.ForceRefTo(ak1)
		lcActor02BRef.ForceRefTo(ak2)
		couplePointer = 2
	ElseIf (couplePointer == 2)
		lcActor03ARef.ForceRefTo(ak1)
		lcActor03BRef.ForceRefTo(ak2)
		couplePointer = 0
	EndIf
EndFunction


Function StartSwingWithCouple(int i)
	Actor Ak1 = lcActor01ARef.GetActorReference()
	Actor Ak2 = lcActor01BRef.GetActorReference()
	
	If (i == 1)
		Ak1 = lcActor02ARef.GetActorReference()
		Ak2 = lcActor02BRef.GetActorReference()
	ElseIf (i == 2)
		Ak1 = lcActor03ARef.GetActorReference()
		Ak2 = lcActor03BRef.GetActorReference()
	EndIf
	
	Actor[] couple1 = new Actor[2]
	Actor[] couple2 = new Actor[2]
	
	couple1[0] = lcPlayer.PlayerRef
	If (Ak1.GetLeveledActorBase().GetSex() == lcPlayer.PlayerRef.GetLeveledActorBase().GetSex())
		couple1[1] = Ak2
		couple2[0] = Ak1
	Else
		couple1[1] = Ak1
		couple2[0] = Ak2
	EndIf
	
	Actor akSpouse = lcPlayer.GetSpouse()
	
	Actor akFollower = None
	if (lcPlayer.lcCurrentFollowers.length > 0)
		akFollower = lcPlayer.lcCurrentFollowers[0]
	EndIf
	
	If (akSpouse != None)
		If (akSpouse.GetParentCell() == lcPlayer.PlayerRef.GetParentCell())
			couple2[1] = akSpouse
		EndIf
	EndIf
	
	If (akFollower != None && couple2[1] == None)
		If (akFollower.GetParentCell() == lcPlayer.PlayerRef.GetParentCell())
			couple2[1] = akFollower
		EndIf
	EndIf
	
	If (couple1[1] != None && couple2[0] != None && couple2[1] != None)
		lcPlayer.MakeLove(couple1)
		Utility.Wait(1.0)
		lcPlayer.MakeLove(couple2)
	EndIf
EndFunction