Scriptname LoversComfortUtilScr extends Quest

; vanilla
Actor Property PlayerRef Auto
GlobalVariable Property GameHour Auto
Faction Property currentFollowerFaction Auto
Keyword Property pLocTypeHabitation Auto

; lovers comfort
Faction Property lcLoverFaction Auto
Faction Property lcSpecialFollowerFaction Auto
LoversComfortPlayerScr Property lcPlayerQuest Auto
LoversComfortConfigScr Property lcConfigQuest Auto
slaUtilScr Property slaUtil Auto

; SexLab
SexLabFramework property SexLab auto

; persistent variables
int modVersion

Event OnInit()
	Maintenance()
EndEvent


Function Maintenance()
	int newVersion = 20131216
	
	If modVersion < 20130824
		lcConfigQuest.SpouseArousalThreshold = 50
	EndIf
	
	If modVersion < 20131207
		lcPlayerQuest.lcSpouseLoverRef.ForceRefTo(None)
	EndIf
	
	If modVersion < newVersion
		modVersion = newVersion
		Debug.Notification("Lover's Comfort version : " + modVersion)
	EndIf
	
	lcPlayerQuest.Maintenance()
	lcConfigQuest.Maintenance()
EndFunction


int Function GetVersion()
	return modVersion
EndFunction


bool Function IsCurrentFollower(Actor akRef)
	If (akRef == None)
		return false
	EndIf
	
	If (akRef.GetFactionRank(currentFollowerFaction) >= 0 || akRef.GetFactionRank(lcSpecialFollowerFaction) >= 0 )
		return true
	EndIf
	
	return false
EndFunction


Int Function IsValidActor(Actor akRef)
	If (akRef == None)
		return -1
	ElseIf (akRef == PlayerRef)
		return -2
	ElseIf (akRef.IsDead())
		return -3
	ElseIf (akRef.IsDisabled())
		return -4
	ElseIf (akRef.IsChild())
		return -5
	ElseIf (akRef.IsInCombat())
		return -6
	ElseIf (akRef.IsGhost())
		return -7
	ElseIf (akRef.IsHostileToActor(PlayerRef))
		return -8
	ElseIf (akRef.HasKeyWordString("ActorTypeCreature"))
		return -9
	ElseIf (akRef.IsInFaction(SexLab.AnimatingFaction))
		return -10
	ElseIf (HasCoolDownTime(akRef))
		return -11
	EndIf
	
	return 1
EndFunction


int Function GetSpouseLoverRank(Actor akRef)
	If (akRef == None)
		return -2
	EndIf
	
	Return akRef.GetFactionRank(lcLoverFaction)
EndFunction


int Function UpdateSpouseLoverRank(Actor akRef, int val)
	If (akRef == None)
		return -2
	EndIf
	
	int newVal = GetSpouseLoverRank(akRef) + val
	
	If (val < -7)
		newVal = -2
	ElseIf (newVal < 0)
		newVal = 0
	ElseIf (newVal > 5)
		newVal = 5
	EndIf
	
	akRef.SetFactionRank(lcLoverFaction, newVal)
	
	return newVal
EndFunction


bool Function  HasCoolDownTime(Actor akRef)
	int tmpVal = slaUtil.GetActorHoursSinceLastSex(akRef)
	
	If (0 <= tmpVal && tmpVal <= 6)
		return true
	EndIf
	
	return false
EndFunction


ObjectReference Function FindClosestObjectOfType(ObjectReference arCenter, int formTypeFilter)
	If (arCenter == None)
		return None
	EndIf
	
	Cell currentCell = PlayerRef.GetParentCell()
	int itemCount = currentCell.GetNumRefs(formTypeFilter)
	ObjectReference bestRef = None
	
	If (itemCount > 0)
		bestRef = currentCell.GetNthRef(0, formTypeFilter)
	Else
		return None
	EndIf
	
	int i = 1
	While (i < itemCount)
		i += 1
		ObjectReference tmpRef = currentCell.GetNthRef(i, formTypeFilter)
		If arCenter.GetDistance(tmpRef) < arCenter.GetDistance(bestRef)
			bestRef = tmpRef
		EndIf
	EndWhile
	
	return bestRef
EndFunction


Bool Function IsInSameSettlement(Actor ak1, Actor ak2)
	If (ak1 == None || ak2 == None)
		Return False
	EndIf
	
	Return ak1.getCurrentLocation().IsSameLocation(ak2.getCurrentLocation(), pLocTypeHabitation)
EndFunction